//+----------------------------------------------------------------------------+
//|                                                 e-CloseByLossOrProfit.mq4  |
//|                                                      . aka KimIV  |
//|                                                       http://www.kimiv.ru  |
//|                                                                            |
//|  05.01.2007               |
//|                    .                  |
//+----------------------------------------------------------------------------+
#property copyright "  . aka KimIV"
#property link      "http://www.kimiv.ru"

//-------    ------------------------------------------
extern string _P_Expert = "----------  ";
extern bool   CurSymbolOnly   = True;            //   
extern double TargetLoss      = 30;              //  
extern double TargetProfit    = 60;              //  
extern bool   ShowComment     = True;            //  
extern int    NumberAccount   = 0;               //   
extern bool   UseSound        = False;           //   
extern string NameFileSound   = "expert.wav";    //   
extern int    Slippage        = 3;               //  
extern int    NumberOfTry     = 5;               //  
extern int    PauseAfterError = 75;              //     

//-------    --------------------------------------
color clCloseBuy  = Blue;         //    
color clCloseSell = Red;          //    

//-------    -------------------------------------------
#include <stdlib.mqh>


//+----------------------------------------------------------------------------+
//|  expert initialization function                                            |
//+----------------------------------------------------------------------------+
void init() { if (!IsTesting()) Comment(""); }

//+----------------------------------------------------------------------------+
//|  expert deinitialization function                                          |
//+----------------------------------------------------------------------------+
void deinit() { if (!IsTesting()) Comment(""); }

//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  string st;

  if (!IsTesting()) {
    if (NumberAccount>0 && NumberAccount!=AccountNumber()) {
      Message("    "+AccountNumber());
      return;
    } else Comment("");
  }

  if (AccountProfit()<-TargetLoss || AccountProfit()>TargetProfit) CloseAllPositions();
  if (ShowComment) {
    st=" ="+DoubleToStr(-TargetLoss,2)+" "+AccountCurrency()+"  ";
    if (AccountProfit()<0) st=st+" =";
    else st=st+" =";
    st=st+DoubleToStr(AccountProfit(),2)+"   ="+DoubleToStr(TargetProfit,2)+" "+AccountCurrency();
    Comment(st);
  }
}


//+----------------------------------------------------------------------------+
//|                                           |
//+----------------------------------------------------------------------------+
void CloseAllPositions() {
  bool   fc;
  double pp;
  int    d, err, i, it, k=OrdersTotal();

  for (i=k-1; i>=0; i--) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (!CurSymbolOnly || OrderSymbol()==Symbol()) {
        d=MarketInfo(OrderSymbol(), MODE_DIGITS);
        if (d==0) if (StringFind(OrderSymbol(), "JPY")<0) d=4; else d=2;
        fc=False;
        for (it=1; it<=NumberOfTry; it++) {
          while (!IsTradeAllowed()) Sleep(5000);
          RefreshRates();
          if (OrderType()==OP_BUY) {
            pp=NormalizeDouble(Bid, d);
            fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseBuy);
            if (fc) {
              if (UseSound) PlaySound(NameFileSound); break;
            } else {
              err=GetLastError();
              Print("Error(",err,") closing buy: ",ErrorDescription(err),", try ",it);
              Sleep(1000*PauseAfterError);
            }
          }
          if (OrderType()==OP_SELL) {
            pp=NormalizeDouble(Ask, d);
            fc=OrderClose(OrderTicket(), OrderLots(), pp, Slippage, clCloseSell);
            if (fc) {
              if (UseSound) PlaySound(NameFileSound); break;
            } else {
              err=GetLastError();
              Print("Error(",err,") closing sell: ",ErrorDescription(err),", try ",it);
              Sleep(1000*PauseAfterError);
            }
          }
        }
      }
    }
  }
}

//+----------------------------------------------------------------------------+
//|                                              |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+

